// ==============================================================
//                 ORBITER MODULE: EAGLEHANGAR2
//                  Part of the ORBITER SDK
//          Copyright (C) 2002-2004 Martin Schweiger
//                   All rights reserved
//
// EAGLEHANGAR2.cpp
// Control module for EAGLEHANGAR2 vessel class
//
// Notes:
// This is an example for a "minimal" vessel implementation which
// only overloads the clbkSetClassCaps method to define vessel
// capabilities and otherwise uses the default VESSEL class
// behaviour.
// ==============================================================
const double FUELMASS = 8377;
const double ISP = 50000.0;
const double ISPAB = 10000.0;

const double MAXMAINTH =55600;
const double MAXMAINTHAB =48930;

const double PB_MAXRCSTH =0;
const double PB_ISP = 0;


//#include "orbitersdk.h"
#include "UMmuSDK.h"

// ==============================================================
// Some vessel parameters
// ==============================================================

// Interface for derived vessel class: QJBStar
// ==========================================================

class GLIDER: public VESSEL2 {
public:
    GLIDER (OBJHANDLE hObj, int fmodel);
	void clbkSaveState(FILEHANDLE scn);
       void clbkPostCreation (void);
	void clbkSetClassCaps (FILEHANDLE cfg);
	void clbkLoadStateEx (FILEHANDLE scn, void *status);
	int clbkConsumeBufferedKey(DWORD key, bool down, char *kstate);
	void clbkVisualCreated (VISHANDLE vis, int refcount);
 	void DefineAnimations(void); 
	void clbkVisualDestroyed (VISHANDLE vis, int refcount);
	void clbkPostStep (double simtt, double simdt, double mjd);
	void clbkDrawHUD (int mode, const HUDPAINTSPEC *hps, HDC hDC);
void GLIDER::SelectCockpitView (int CAM);

	void RevertGEAR (void);
		void RevertCANOPY1 (void);
				void RevertCANOPY2 (void);

enum GEAR_status { GEAR_UP, GEAR_DOWN, GEAR_RAISING, GEAR_LOWERING } GEAR_status,CANOPY1_status,CANOPY2_status;


	THRUSTER_HANDLE   th_first[2],th_AB[2],th_rcs[4], th_group[2], th_att_rot[4],th_att_lin[4], th_hover[1];
SURFHANDLE		  tex;
UINT MAIN,MAINVC;

bool clbkLoadVC(int id);
	double speedbrake;

BEACONLIGHTSPEC APbeacon[3];
VECTOR3 APbeaconpos[3];
int j;

double ATMD1,ATMadjusted,ATMD2,ATMD3,ATMABadjusted,gear_pos;




double LIFT_SPEED,GEAR_proc,CANOPY1_proc,CANOPY2_proc,FLAP_proc;
//double DOOR2_proc;
//double TCAR_proc; 
double db,simdt,STICK1Z,STICK1X,STICK1Z1,STICK1X1,STICK1Z2,STICK1X2,PEDALL,PEDALR,PEDALBOTH,THROTTLE1;
UINT BUG0,CREW1;
MESHHANDLE TUBE;







//void Estado();
// UMMU 2.0 DECLARATION
	UMMUCREWMANAGMENT Crew;
	int SelectedUmmuMember;				// for the SDK demo, select the member to eva
	int iActionAreaDemoStep;			// this is just to show one feature of action area.
	void clbkSetClassCaps_UMMu(void);	// our special SetClassCap function just added for more readability

	// The HUD display method variable, see PDF doc
	char cUmmuHudDisplay[255];			// UMmu hud char variable
	double dHudMessageDelay;			// UMmu hud display delay
	char *SendHudMessage(void);			// UMmu hud display function

	// THIS IS FOR ADDING CREW SEE PDF doc "Allow user to add crew to your ship 
	// without scenery editor"
	char cAddUMmuToVessel[255];
	void AddUMmuToVessel(BOOL bStartAdding=FALSE);
private:
int CAM,GLIDERPSoundID;
int MOONBASEALPHA2ID;


UINT anim_GEARlever;
UINT anim_THROTTLE;

UINT anim_GEAR;
UINT anim_CANOPY2;
UINT anim_CANOPY1;
UINT anim_flaps;
UINT anim_raileron;
UINT anim_laileron;
UINT anim_ELEVATOR;
UINT anim_RUDDER;
UINT anim_LGEAR;
UINT anim_STICKX;
UINT anim_STICKZ;
UINT anim_SPEEDBRAKE;
UINT anim_PEDAL1;
UINT anim_PEDAL2;

};